PONG2  LOC1	EQU	341		 KEYBOARD SCAN LOCS
 LOC2	EQU	342
 LOC3	EQU	344
 LOC4	EQU	339
 NOPLAY	EQU	3700		 AREA ABOVE BASIC PROG
 XBALL	EQU	NOPLAY+1
 YBALL	EQU	XBALL+1
 DELTAX	EQU	YBALL+1
 DELTAY	EQU	DELTAX+1
 LFTPDL	EQU	DELTAY+1
 RGTPDL	EQU	LFTPDL+1
 LFTCLR	EQU	RGTPDL+1
 RGTCLR	EQU	LFTCLR+1
 STATUS	EQU	RGTCLR+1
 XCOORD	EQU	STATUS+1
 YCOORD	EQU	XCOORD+1
 COLOR	EQU	YCOORD+1
 OPTION	EQU	COLOR+1
 RESULT	EQU	OPTION+1
 DOTBIT	EQU	RESULT+1
 	PSHS	D,X,Y,CC	 SAVE REGISTERS
 	BSR	MVPDL1		 MOVE LEFT PADDLE
 	LDA	NOPLAY		 GET NUMBER OF PLAYERS
 	CMPA	#2		 2 PLAYERS?
 	BNE	AHEAD1		 NO - CONTINUE
 	BSR	MVPDL2		 YES - MOVE RIGHT PADDLE
 AHEAD1	CLR	STATUS		 CLEAR STATUS
 	LBSR	MVBALL		 MOVE BALL - SET STATUS
 	BSR	MVPDL1		 MOVE PADDLE 1
 	LDA	NOPLAY		 NO. OF PLAYERS ?
 	CMPA	#2
 	BNE	GETOUT		 1 - CONT
 	BSR	MVPDL2		 2 - MOVE PADDLE
 GETOUT	PULS	D,CC,X,Y
 	RTS			 RETURN TO BASIC PROGRAM
 *
 *	MOVE LEFT PADDLE SUBROUTINE
 *
 MVPDL1	LDA	#$00FF		 RESET KEYIN BITS FOR NEW
 	STA	LOC1			KEYBOARD READ
 	STA	LOC2
 	LDA	#1		 LEFT PADDLE X - COORD
 	STA	XCOORD		 SAVE FOR SUBRTN CALL
 	LDA	LFTCLR		 LEFT PADDLE COLOR
 	STA	COLOR		 STORE FOR SUBRTN CALL
 	CLR	OPTION		 0 = SET OPTION
 	JSR	!$A000!		 POLL KEYBOARD
 	CMPA	#$005E		 UP ARROW ?
 	BNE	AHEAD2		 NO - CONTINUE
 	LDA	LFTPDL		 GET CURENT PADDLE POS.
 	CMPA	#3		 UPPER BOUND ?
 	BEQ	PD1OUT		 YES - EXIT
 	SUBA	#1		 NEW = OLD - 1
 	STA	LFTPDL		 SAVE NEW POSITION
 	SUBA	#1		 A = NEW POS TO SET
 	STA	YCOORD		 STORE Y FOR SUBRTN CALL
 	LBSR	SRPSBR		 SET NEW POINT
 	ADDA	#3		 A = OLD POS TO RESET
 	STA	YCOORD		 STORE Y FOR SUBRTN CALL
 	LDB	#1		 1 = RESET 
 	STB	OPTION		 SET UP CALL
 	LBSR	SRPSBR		 RESET OLD POINT
 	BRA	PD1OUT		 EXIT
 AHEAD2	CMPA	#$000A		 DOWN ARROW ?
 	BNE	PD1OUT		 NO - EXIT
 	LDA	LFTPDL		 GET LEFT PADDLE POS
 	CMPA	#28		 LAST POSITION ?
 	BEQ	PD1OUT		 YES - EXIT
 	ADDA	#1		 POINT TO NEW POS
 	STA	LFTPDL		 STORE NEW POS
 	ADDA	#1		 NEW POINT TO SET
 	STA	YCOORD		 SAVE FOR SUBRTN
 	LBSR	SRPSBR		 TURN ON POINT
 	SUBA	#3		 OLD POINT TO RESET
 	STA	YCOORD		 SAVE FOR SUBRTN
 	LDA	#1		 OPTION = RESET
 	STA	OPTION
 	LBSR	SRPSBR		 RESET OLD POINT
 PD1OUT	RTS			 EXIT
 *
 *	MOVE RIGHT PADDLE SUBROUTINE
 *
 MVPDL2	LDA	#$00FF		 RESET CURRENT KEY-IN
 	STA	LOC3			FOR NEW READ
 	STA	LOC4
 	LDA	#62		 COLUMN = 62 FOR RIGHT
 	STA	XCOORD		 SAVE FOR SUBRTN CALL
 	LDA	RGTCLR		 GET RIGHT PADDLE COLOR
 	STA	COLOR		 STORE FOR SUBRTN CALL
 	CLR	OPTION		 OPTION = SET
 	JSR	!$A000!		 POLL KEYBOARD
 	CMPA	#9		 LEFT ARROW ?
 	BNE	AHEAD3		 NO - CONTINUE
 	LDA	RGTPDL		 GET RIGHT POSITION
 	CMPA	#3		 UPPER LIMIT ?
 	BEQ	PD2OUT		 YES - EXIT
 	SUBA	#1		 NEW POS = OLD - 1
 	STA	RGTPDL		 STORE NEW POSITION
 	SUBA	#1		 POINT TO SET
 	STA	YCOORD		 SAVE FOR SUBRTN CALL
 	LBSR	SRPSBR		 SET NEW POINT
 	ADDA	#3		 POINT TO RESET
 	STA	YCOORD		 SAVE IT
 	LDB	#1		 1 = RESET
 	STB	OPTION		 OPTION = RESET
 	LBSR	SRPSBR		 RESET OLD POINT
 	BRA	PD2OUT		 EXIT
 AHEAD3	CMPA	#$000C		 CLEAR KEY ?
 	BNE	PD2OUT		 NO - EXIT
 	LDA	RGTPDL		 GET RIGHT POS
 	CMPA	#28		 LOWER LIMIT ?
 	BEQ	PD2OUT		 YES - EXIT
 	ADDA	#1		 NEW POS = OLD POS + 1
 	STA	RGTPDL		 SAVE NEW POS
 	ADDA	#1		 NEW POINT TO SET
 	STA	YCOORD		 SAVE FOR SUBRTN CALL
 	LBSR	SRPSBR		 SET NEW POINT
 	SUBA	#3		 POINT TO RESET
 	STA	YCOORD		 SAVE IT
 	LDB	#1		 I = RESET
 	STB	OPTION		 OPTION = RESET
 	LBSR	SRPSBR		 RESET POINT
 PD2OUT	RTS			 EXIT
 *
 *	MOVE BALL SUBROUTINE
 *
 MVBALL	LDA	#1		 OPTION = RESET
 	STA	OPTION
 	LDA	#5		 COLOR = WHITE
 	STA	COLOR
 	LDA	XBALL		 GET BALL X-COORD
 	STA	XCOORD		 STORE IT
 	LDB	YBALL		 GET BALL Y-COORD
 	STB	YCOORD		 STORE IT
 	LBSR	SRPSBR		 RESET OLD BALL
 	ADDA	DELTAX		 GET NEW X-POS
 	ADDB	DELTAY		 GET NEW Y-POS
 SKIP1	STA	XBALL		 STORE NEW X COORD
 	STA	XCOORD
 	CMPB	#2
 	BGE	SKIP2		 >= 2 - SKIP
 	LDB	#2
 SKIP2	CMPB	#29
 	BLE	SKIP3		<= 28 - SKIP
 	LDB	#29
 SKIP3	STB	YBALL		STORE NEW Y VALUE
 	STB	YCOORD
 	CLR	OPTION		 OPTION = SET
 	LBSR	SRPSBR		 SET NEW BALL
 	CMPA	#2		 LEFT BORDER ?
 	BNE	BALL1		 NO - CHECK RIGHT
 	SUBB	LFTPDL		 PADDLE POS - Y COORD
 	BRA	BALL2		 JUMP AROUND RIGHT LOGIC
 BALL1	CMPA	#61		 RIGHT BORDER ?
 	BNE	BALL4		 NO - MISSED BALL
 	PSHS	A		 SAVE A
 	LDA	NOPLAY		 2 PLAYERS ?
 	CMPA	#2
 	PULS	A		 RESTORE A
 	BEQ	PATCH1		 2 - CONT
 	LDB	#1
 	STB	STATUS
 	LDB	#16
 	BRA	PATCH2		 1 PLAYER
 PATCH1	SUBB	RGTPDL		 BALL & PADDLE POS
 BALL2	STB	DELTAY		 IF HIT - NEW DELTA Y
 PATCH2	NEG	DELTAX		 DELTA X = - DELTA X
 	CMPB	#$00FF		 MINUS ONE ?
 	BEQ	BALL3		 YES - STATUS = HIT
 	CMPB	#0		 0 ?
 	BEQ	BALL3		 YES - STATUS = HIT
 	CMPB	#1		 1 ?
 	BEQ	BALL3		 YES - STATUS = HIT
 	CMPA	#61		 RIGHT LIMIT ?
 	BNE	BALL2B		 NO - STATUS = MISSED
 	LDA	NOPLAY		 GET NO. OF PLAYERS
 	CMPA	#2		 2 ?
 	BEQ	BALL2A		 YES - CHECK HIT/MISS
 	NEG	DELTAX		 NO - DELTAX= -DELTAX
 	BRA	BALL4		 CHECK BORDERS
 BALL2A	LDA	#4		 STATUS = RIGHT MISS
 	STA	STATUS
 	BRA	BALOUT		 EXIT
 BALL2B	LDA	#3		 STATUS = LEFT MISS
 	STA	STATUS
 	BRA	BALOUT		 EXIT
 BALL3	LDA	#2		 STATUS = PADDLE HIT
 	STA	STATUS
 	BRA	BALOUT		 EXIT
 BALL4	CMPB	#2		 CHECK UPPER BOUND
 	BLE	BALL5		 YES - SET STATUS
 	CMPB	#29		 CHECK LOWER BOUND
 	BGE	BALL5		 YES - SET STATUS
 	BRA	BALOUT		 GET OUT
 BALL5	NEG	DELTAY		 DELTA Y = - DELTA Y
 	LDA	#1		 STATUS = BOUNDRY HIT
 	STA	STATUS
 BALOUT	RTS			 EXIT
 SRPSBR	EQU	*		 ADD CODE FOR GRAPHICS
29		 CHECK LOWER BOUND
 	BGE	BALL5		 YES - SET STATUS
 	BRA	BALOUT		 GET OUT
 BALL5	NEG	DELTAY		 DELTA Y = - DELTA Y
 	LDA	#1		 